<dom-module id="sc-scrollable-container">
    <template>
        <iron-signals on-iron-signal-move-container="scroll"></iron-signals>
        <content></content>
    </template>

    <script>
        Polymer({

            is:'sc-scrollable-container',

            listeners:{
                'down':'down',
                'track':'track',
                'tap':'tap'
            },

            attached: function(event) {
                this.fullScreenMode = document.webkitIsFullScreen;
                this.smallScreen = window.innerHeight;
                this.currentHeight = this.smallScreen
            },

            down: function(event) {
                event.preventDefault();
                this.start = event.timeStamp; 
                this.startX = event.detail.x;
                this.fire('iron-signal',{
                    name:'down',
                    data: {
                        x:event.detail.x,
                        y:event.detail.y
                    }
                })
            },

            tap: function(event) {
                event.preventDefault();
                if (!this.firstTap) {
                    this.firstTap = event.timeStamp;
                }
                if (event.timeStamp - this.firstTap > 200) {
                    this.fullScreen();
                    this.firstTap= null;
                }
                else {
                    this.click(event);
                }
            },

            click: function(event) {
                this.fire('iron-signal',{
                    name:'click',
                    data: {}
                })
            },

            track: function(event) {
                event.preventDefault();
                if (event.detail.state == "start") {
                    this.clickDuration = event.timeStamp - this.start;
                    if(event.detail.dx > 0) {
                        this.direction = 1;
                    }
                    else {
                        this.direction = -1;
                    }
                }
                
                if (this.clickDuration < 20) {
                    this.move(this.direction*event.detail.x,true);
                    name = "cancel"
                }
                else if (this.clickDuration < 500) {
                    this.move(this.direction*event.detail.x/4,true);
                    name="cancel"
                }
                else {
                    this.draw(event.detail.dx,event.detail.dy,event.target.id,event.target.className.baseVal);
                    name="select"
                }

                if (event.detail.state == "end") {
                    this.fire('iron-signal',{
                        name:name,
                        data: {}
                    })
                }
            },

            move:function(x,frame) {
                this.fire('iron-signal',
                        {
                            name:'move-image',
                            data: {
                                x:x,
                                frame:frame
                            }
                        }
                    )
            },

            draw:function(x,y,id,className) {
                this.fire('iron-signal',
                        {
                            name:'draw',
                            data: {
                                w: x,
                                h: y,
                                startX:this.startX,
                                id:id,
                                class:className
                            }
                        }
                    )
            },

            scroll:function(event,detail) {
                this.move(detail.x,false);
            },

            fullScreen: function() {
                //TODO : adapter la place du groupe avec les rectangles aux nouvelles dimensions 
                if (this.fullScreenMode) {
                    document.webkitExitFullscreen();
                    this.fullScreenMode = false;
                    this.currentHeight = this.smallScreen
                }
                else {
                    document.documentElement.webkitRequestFullscreen();
                    this.fullScreenMode = true;
                    this.currentHeight = window.screen.availHeight;
                }
                this.adaptContent();
            },

            adaptContent: function() {
                this.fire('iron-signal',{
                    name:'resize-content',
                    data: {
                        windowHeight:this.currentHeight
                    }
                })
            }
        })
    </script>
</dom-module>